package com.ruoyi.info.service.enums;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.ruoyi.common.enums.IIntegerEnum;

import java.util.Objects;

public enum ServiceUnit implements IIntegerEnum<Integer> {

    day(0, "天"),
    hour(1, "小时"),
    time(2, "次"),
    cover(3, "套"),
    ;

    ServiceUnit(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    @EnumValue
    @JsonValue
    private Integer code;

    private String msg;

    @Override
    public Integer getCode() {
        return code;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    @Override
    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    @JsonCreator
    public static ServiceUnit getByCode(Integer code) {
        for (ServiceUnit value : ServiceUnit.values()) {
            if (Objects.equals(code, value.getCode())) {
                return value;
            }
        }
        return null;
    }

    //转成jsonarray
    public static JSONArray toJsonArray() {
        JSONArray jsonArray = new JSONArray();
        for (ServiceUnit value : ServiceUnit.values()) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("code", value.getCode());
            jsonObject.put("value", value.getMsg());
            jsonArray.add(jsonObject);
        }
        return jsonArray;
    }

}
